//+------------------------------------------------------------------+
//|                                                    ADXFilter.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                                                Written by mj_bolt|   
//|                                                                  |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_minimum -0.05
#property indicator_maximum 1.05
#property indicator_buffers 4
#property indicator_color1 C' 23,139, 23'
#property indicator_color2 C'255, 32, 32'
#property indicator_color3 C' 90,185, 90'
#property indicator_color4 C'255,185,185'



//---- input parameters
extern int PeriodADX=4;

//---- indicator buffers
double UpBuffer1[];
double DnBuffer1[];
double UpBuffer2[];
double DnBuffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
   
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,5);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,5);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,5);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,5);
   
   SetIndexBuffer(0,UpBuffer1);
   SetIndexBuffer(1,DnBuffer1);
   SetIndexBuffer(2,UpBuffer2);
   SetIndexBuffer(3,DnBuffer2);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   
//---- name for DataWindow and indicator subwindow label
   short_name="ADX Filter("+PeriodADX+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DownTrend");
   SetIndexLabel(2,"Mild UpTrend");
   SetIndexLabel(3,"Mild DownTrend");
   
//----
   SetIndexDrawBegin(0,PeriodADX);
   SetIndexDrawBegin(1,PeriodADX);
   SetIndexDrawBegin(2,PeriodADX);
   SetIndexDrawBegin(3,PeriodADX);
     
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| ADXFilter                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int shift,trend;
   double ADX0,ADX1,ADX2;

   
   for(shift=Bars-PeriodADX-1;shift>=0;shift--)
   {	
   ADX0=iADX(NULL,0,PeriodADX,PRICE_CLOSE,MODE_MAIN,shift);
   ADX1=iADX(NULL,0,PeriodADX,PRICE_CLOSE,MODE_PLUSDI,shift);
   ADX2=iADX(NULL,0,PeriodADX,PRICE_CLOSE,MODE_MINUSDI,shift);
   	
	  if (ADX0<20 && ADX1>ADX2)  trend=1;
	  if (ADX0>20 && ADX1>ADX2)  trend=2;  
	  if (ADX0<20 && ADX2>ADX1)  trend=-1;
	  if (ADX0>20 && ADX2>ADX1)  trend=-2;
	  
	  if (trend==1) 
	  {
	  
	  UpBuffer1[shift]=0;
	  UpBuffer2[shift]=1;
	  DnBuffer1[shift]=0;
	  DnBuffer2[shift]=0;
	  
	  }
	  if (trend==2) 
	  {
	  
	  UpBuffer1[shift]=1;
	  UpBuffer2[shift]=0;
	  DnBuffer1[shift]=0;
	  DnBuffer2[shift]=0;
	  
	  }
	  if (trend==-1) 
	  {
	   
	  UpBuffer1[shift]=0;
	  UpBuffer2[shift]=0;
	  DnBuffer1[shift]=0;
	  DnBuffer2[shift]=1;
	  }
	  
	  if (trend==-2) 
	  {
	  
	  UpBuffer1[shift]=0;
	  UpBuffer2[shift]=0;
	  DnBuffer1[shift]=1;
	  DnBuffer2[shift]=0; 
	  
	  }
	}
	return(0);	
 }

